/*
CRM API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package crmapi

import (
	"encoding/json"
)

// checks if the CreateDNConfigRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateDNConfigRequest{}

// CreateDNConfigRequest struct for CreateDNConfigRequest
type CreateDNConfigRequest struct {
	ClientId string `json:"client_id"`
	ClientSecret string `json:"client_secret"`
	ApiUrl string `json:"api_url"`
}

// NewCreateDNConfigRequest instantiates a new CreateDNConfigRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateDNConfigRequest(clientId string, clientSecret string, apiUrl string) *CreateDNConfigRequest {
	this := CreateDNConfigRequest{}
	this.ClientId = clientId
	this.ClientSecret = clientSecret
	this.ApiUrl = apiUrl
	return &this
}

// NewCreateDNConfigRequestWithDefaults instantiates a new CreateDNConfigRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateDNConfigRequestWithDefaults() *CreateDNConfigRequest {
	this := CreateDNConfigRequest{}
	return &this
}

// GetClientId returns the ClientId field value
func (o *CreateDNConfigRequest) GetClientId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value
// and a boolean to check if the value has been set.
func (o *CreateDNConfigRequest) GetClientIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ClientId, true
}

// SetClientId sets field value
func (o *CreateDNConfigRequest) SetClientId(v string) {
	o.ClientId = v
}

// GetClientSecret returns the ClientSecret field value
func (o *CreateDNConfigRequest) GetClientSecret() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value
// and a boolean to check if the value has been set.
func (o *CreateDNConfigRequest) GetClientSecretOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ClientSecret, true
}

// SetClientSecret sets field value
func (o *CreateDNConfigRequest) SetClientSecret(v string) {
	o.ClientSecret = v
}

// GetApiUrl returns the ApiUrl field value
func (o *CreateDNConfigRequest) GetApiUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiUrl
}

// GetApiUrlOk returns a tuple with the ApiUrl field value
// and a boolean to check if the value has been set.
func (o *CreateDNConfigRequest) GetApiUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiUrl, true
}

// SetApiUrl sets field value
func (o *CreateDNConfigRequest) SetApiUrl(v string) {
	o.ApiUrl = v
}

func (o CreateDNConfigRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateDNConfigRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["client_id"] = o.ClientId
	toSerialize["client_secret"] = o.ClientSecret
	toSerialize["api_url"] = o.ApiUrl
	return toSerialize, nil
}

type NullableCreateDNConfigRequest struct {
	value *CreateDNConfigRequest
	isSet bool
}

func (v NullableCreateDNConfigRequest) Get() *CreateDNConfigRequest {
	return v.value
}

func (v *NullableCreateDNConfigRequest) Set(val *CreateDNConfigRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateDNConfigRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateDNConfigRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateDNConfigRequest(val *CreateDNConfigRequest) *NullableCreateDNConfigRequest {
	return &NullableCreateDNConfigRequest{value: val, isSet: true}
}

func (v NullableCreateDNConfigRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateDNConfigRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


